/**
 *
 * Magnolia generic utilities (http://www.openmindlab.com/lab/products/mgnlutils.html)
 * Copyright(C) 2009-2010, Openmind S.r.l. http://www.openmindonline.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package it.openutils.mgnlutils.el;

import org.testng.Assert;
import org.testng.annotations.Test;


/**
 * @author dschivo
 * @version $Id: MgnlUtilsElFunctionsTest.java 2129 2010-03-09 20:22:57Z fgiust $
 */
public class MgnlUtilsElFunctionsTest
{

    @Test
    public void testSplitAndTokenize() throws Exception
    {
        String text = "lorem" + '\t' + "ipsum" + "\r\n" + "dolor" + '\t' + "sit";
        String[][] result = MgnlUtilsElFunctions.splitAndTokenize(text);
        Assert.assertNotNull(result);
        Assert.assertEquals(result.length, 2);
        String[] row1 = result[0];
        String[] row2 = result[1];
        Assert.assertNotNull(row1);
        Assert.assertEquals(row1.length, 2);
        Assert.assertNotNull(row2);
        Assert.assertEquals(row2.length, 2);
        Assert.assertEquals(row1[0], "lorem");
        Assert.assertEquals(row1[1], "ipsum");
        Assert.assertEquals(row2[0], "dolor");
        Assert.assertEquals(row2[1], "sit");
    }

}
